本文主要是介绍Leetcode 1631. 最小体力消耗路径,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!
一、题目
1、题目描述
你准备参加一场远足活动。给你一个二维
rows x columns
的地图heights
,其中heights[row][col]
表示格子(row, col)
的高度。一开始你在最左上角的格子(0, 0)
,且你希望去最右下角的格子(rows-1, columns-1)
(注意下标从 0 开始编号)。你每次可以往 上,下,左,右 四个方向之一移动,你想要找到耗费 体力 最小的一条路径。一条路径耗费的 体力值 是路径上相邻格子之间 高度差绝对值 的 最大值 决定的。
请你返回从左上角走到右下角的最小 体力消耗值 。
2、接口描述
class Solution {
public:int minimumEffortPath(vector<vector<int>>& heights) {}
};
3、原题链接
1631. 最小体力消耗路径
二、解题报告
1、思路分析
显然我们是要找到左上到右下所有路径中最小的体力消耗值,我们不妨定义边权为高度差,随后我们有两种选择:
F1 按照最短路求解
在本题中,我们路径长度变为了路径上最大高度差,那么我们仍然能用最短路求解,我们以Dijkstra为例,我们dist转移从加权转移变为了最大高度差转移
F2 Kruscal
为什么能用Kruscal?当我们执行生成树流程,当加入一条边使得起点终点连通,那么这条边权就是我们的答案。
证明:设最后一条边e
1、往证e在最优路径上
如果e不在最优路径上,那么由于我们按照所有边从边权从大到小取边,e之前的边必已经令起点终点连通,那么不会进行到e的情况,因为我们已经返回答案了
2、往证e的边权是最优路径上最大的
假设前面有边权比e权值大,那么由于我们从权值从小到大取边,e必然比前面的大,又矛盾了
1、2得证
2、复杂度
Dijkstra:
时间复杂度:空间复杂度:
Kruscal:
时间复杂度:空间复杂度:
3、代码详解
Dijkstra
class Solution {
private:typedef pair<int, int> PII; #define N 10010int dir[5]{0,1,0,-1,0};int dist[N];
public:int minimumEffortPath(vector<vector<int>>& heights) {int m = heights.size(), n = heights[0].size();memset(dist, 0x3f, sizeof dist);bitset<N> vis;dist[0] = 0;priority_queue<PII, vector<PII>, greater<>> heap;heap.emplace(0, 0);auto posxy = [&](int id){return PII{id / n, id % n};};auto pos = [&](int x, int y){return x * n + y;};while (heap.size()) {auto t = heap.top();heap.pop();int ver = t.second, w = t.first;if (vis[ver]) continue;vis[ver] = true;auto [x, y] = posxy(ver);for (int i = 0; i < 4; i++) {int nx = x + dir[i], ny = y + dir[i+1];if (nx < 0 || nx >= m || ny < 0 || ny >= n) continue; int nver = pos(nx, ny);int nw = max(w,abs(heights[x][y] - heights[nx][ny]));if(dist[nver] > nw){dist[nver] = nw;heap.emplace(nw, nver);}}}return dist[n * m - 1];}
};
Kruscal
class Solution {
public:
struct edge
{int u , v , w;bool operator<(const edge& e){return w < e.w;}
};
int p[10001];
int findp(int x)
{return p[x] < 0 ? x : p[x] = findp(p[x]);
}
void Union(int x , int y)
{int px = findp(x) , py = findp(y);if(px == py) return;if(p[px] > p[py]) swap(px , py);p[px] += p[py];p[py] = px;
}
bool isUnion(int x , int y)
{return findp(x) == findp(y);
}
static constexpr int dir[]{0 , 1 , 0};int minimumEffortPath(vector<vector<int>>& heights) {memset(p , -1 , sizeof(p));vector<edge> edges;int m = heights.size() , n = heights[0].size();auto pos = [&](int x , int y)->int{return x*n+y;};for(int i = 0 ; i < m ; i++){for(int j = 0 ; j < n ; j++){for(int k = 0 ; k < 2 ; k++){int nx = i + dir[k] , ny = j + dir[k + 1];if(nx >= m || ny >= n) continue;int w = abs(heights[nx][ny] - heights[i][j]);edges.emplace_back(edge{pos(i,j) , pos(nx,ny) , w});}}}long long ret = 0;sort(edges.begin() , edges.end());for(auto& e : edges){if(isUnion(e.u,e.v)) continue;Union(e.u,e.v);if(isUnion(0 , m*n-1)) return e.w;}return ret;}
};
这篇关于Leetcode 1631. 最小体力消耗路径的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!